#<profile4xi profile = "20" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "client4xi.py">
#<abstract4xi abstract = "providing the function Client4Xi"/>
#<refer4xi reference = "connection.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
#<note4xi note = "the function name starts with capital to depict a main function in multiprocessing "/>
# -------------------------------------------------------------------------------------------------


# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'Client4Xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import errno
import io
import itertools
import os
import pickle
import select
import socket
import struct
import sys
import time
import tempfile
try:
    import _winapi
    from _winapi import WAIT_OBJECT_0, WAIT_TIMEOUT, INFINITE
except ImportError:
    if sys.platform == 'win32':
        raise
    _winapi = None 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
from multiprocessing import connection
try:                             # Python ones
    from multiprocessing.connection import Client
except:
    print("client4xi.py *** failed in from multiprocessing.connection import Client ***")  
#"
#/>



# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from address_type4xi import address_type4xi
from answer_challenge4xi import answer_challenge4xi
from constant_family4xi import get_af_pipe4xi
from deliver_challenge4xi import deliver_challenge4xi
from examine4xi import examine4xi

from pipeclient4xi import PipeClient4Xi
from print4xi import print4xi

from socketclient4xi import SocketClient4Xi

from time4xi import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "Client4Xi" usage = "
# 
#   connection.py    
#       XmlClient(*args, **kwds):
#           return ConnectionWrapper(Client(*args, **kwds), _xml_dumps, _xml_loads)
#   SyncManager4Xi:
#        __init__:
#            set self._Client to: <function Client4Xi at 0x00000000038E1748>; time: 23:40:15 09/06/09 FLE Daylight Time}
#   Finalize4Xi:
#        __repr__:
#            Step 4/6b set x to: <finalize4xi: __repr__: Finalize object, callback=_finalize_manager, args=(<Process4Xi(SyncManager4Xi-1, None)>,
#                          None, "b'\\xa7\\xe5\\x11\\xc9\\xc4\\xce\\xa8\\xa2\\xb3[\\x15\\xe5\\xc6\\xaa\\x88h\\x17H\\x83\\xb4\\xda\\x9ft\\xba\\xc2&\\xce\\x90\\x84x^J'", 
#                          <state4xi.State4Xi object at 0x00000000039738E8>, <function Client4Xi at 0x00000000038E1748>); time: 23:40:15 09/06/09 FLE Daylight Time}
#   listener_client4xi.py
#       listener_client4xi = {'pickle' : (Listener4Xi, Client4Xi),..}
#   rebuild_handle4xi.py
#       conn2xi = Client4Xi(address2xi, authkey2xi)
#   xmlclient4xi.py
#       return ConnectionWrapper4Xi(Client4Xi(*args, **kwds), _xml_dumps, _xml_loads)
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def Client4Xi(exchange, family=None, passport=None):
    '''
    returns a connection to the exchange of a Listener
    '''
    
    # ---------------------------------------------------------------------------------------------
    # (Step 1/6) 
    # ---------------------------------------------------------------------------------------------
    class2print = 'Client4Xi'
    method2print = 'Client4Xi'                          # Note: this is function - not a class - used in multiprocessing
    
    message2print = "{(Step 1/6a) started" + "; Client4Xi-started: " + str(Client4Xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        
    message2print = "{(Step 1/6b1) passed" + "; exchange-passed-to-Client4Xi: " + str(exchange) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    if exchange is None:
        message2print = "{(Step 1/6b2) warned" + "; exchange-warned-by-Client4Xi: " + str(exchange)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
    
    if passport is None:
        message2print = "{(Step 1/6b3) warned" + "; passport-warned-by-Client4Xi: " + str(passport)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        passport = os.urandom(32)

        message2print = "{(Step 1/6b4) set" + "; passport-set-by-Client4Xi to: " + str(passport)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        
    message2print = "{(Step 1/6c) passed" + "; family-passed-to-Client4Xi: " + str(family) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
                     
        
    message2print = "{(Step 1/6d) passed" + "; passport-passed-to-Client4Xi: " + str(passport) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
           
    if examine4xi(class2print, method2print):
        # -----------------------------------------------------------------------------------------
        # (StepOriginal):        
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(StepOriginal) passing" + "; exchange-passing-to-Client-by-Client4Xi: " + str(exchange) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
                
        message2print = "{(StepOriginal) passing" + "; family-passing-to-Client-by-Client4Xi: " + str(family) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
                  
        message2print = "{(StepOriginal) passing" + ";  passport-passing-to-Client-by-Client4Xi: " + str(passport) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
          
        
        message2print = "{(StepOriginal) returning" + "; Client-returning-by-Client4Xi: " + str(Client) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        
        message2print = "{(StepOriginal) returning" + "; Client-function-returning-by-Client4Xi: " + str(Client) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                
                
        return Client(exchange, family, passport)
                 
    else:

        # -----------------------------------------------------------------------------------------
        # (Step 2/6)           
        # -----------------------------------------------------------------------------------------
        if exchange is None:
            message2print = "{(Step 2/6a) hit" + "; exchange-hit-by-Client4Xi: " + " *** FATAL ERROR TO-BE-SOLVED  exchange to Client4Xi: " + str(exchange)  + " *** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            
            message2print = "{(Step 2/6b) yielded" + "; exchange-yielded-by-Client4Xi: " + str(exchange)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
        # -----------------------------------------------------------------------------------------
        # (Step 3/6)           
        # -----------------------------------------------------------------------------------------   
        try:
            family = family or address_type4xi(exchange) 
        
            message2print = "{(Step 3/6a) set" + "; family-set-by-Client4Xi to: " + str(family)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
        except:
            message2print = "{(Step 3/6b) hit" + "; family-hit-by-Client4Xi: " + " *** " + str(family)  + " *** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
                           
        
        if family == get_af_pipe4xi():
            # -------------------------------------------------------------------------------------    
            #
            # -------------------------------------------------------------------------------------                 
            message2print = "{(Step 3/6a1) passing" + "; exchange-passing-to-PipeClient4Xi-by-Client4Xi: " + str(exchange) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
        

            connection2xi = PipeClient4Xi(exchange)
     
            message2print = "{(Step 3/6a2) got" + "; connection2xi-got-by-Client4Xi: " + str(connection2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
                
                            

        else:
            # -------------------------------------------------------------------------------------    
            #
            # ------------------------------------------------------------------------------------- 
            message2print = "{(Step 3/6b1) passing" + "; exchange-passing-to-SocketClient4Xi-by-Client4Xi: " + str(exchange) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          

            connection2xi = SocketClient4Xi(exchange)
            
            message2print = "{(Step 3/6b2) got" + "; connection2xi-got-by-Client4Xi: " + str(connection2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
                
            
    
        # -----------------------------------------------------------------------------------------
        # (Step 4/6)          
        # -----------------------------------------------------------------------------------------
        if passport is not None and not isinstance(passport, bytes):
            
            message2print = "{(Step 4/6a) raising" + "; TypeError-raising-by-Client4Xi: " + str(TypeError) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 

            message2print = "{(Step 4/6b) hit" + "; passport-hit-by-Client4Xi: " + " *** " + str(passport)  + " *** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)

 
            
        # -----------------------------------------------------------------------------------------
        # (Step 5/6)          
        # -----------------------------------------------------------------------------------------    
        if passport is not None:
            # -------------------------------------------------------------------------------------    
            #
            # -------------------------------------------------------------------------------------     
            message2print = "{(Step 5/6a1) passing" + "; connection2xi-passing-to-answer-challenge-by-Client4Xi: " + str(connection2xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
        
            message2print = "{(Step 5/6a2) passing" + "; passport-passing-to-answer-challenge-by-Client4Xi: " + str(passport) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            
            # -------------------------------------------------------------------------------------    
            #
            # -------------------------------------------------------------------------------------                      
            try:
                answer_challenge4xi(connection2xi, passport)
    
                message2print = "{(Step 5/6a3) performed" + "; answer-challenge-performed-by-Client4Xi: " + str(answer_challenge4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)      
            except:
                message2print = "{(Step 5/6a4) hit" + "; answer-challenge4xi-hit-by-Client4Xi: " + " *** " + str(answer_challenge4xi)  + " *** " + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                        
                
            # -------------------------------------------------------------------------------------    
            #
            # -------------------------------------------------------------------------------------                     
    
            message2print = "{(Step 5/6a4) passing" + "; connection2xi-passing-to-deliver-challenge-by-Client4Xi: " + str(connection2xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  

            message2print = "{(Step 5/6a5) passing" + "; passport-passing-to-deliver-challenge-by-Client4Xi: " + str(passport) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            
            # -------------------------------------------------------------------------------------    
            #
            # -------------------------------------------------------------------------------------                                      
            try:
                deliver_challenge4xi(connection2xi, passport)
            
                message2print = "{(Step 5/6a6) performed" + "; deliver-challenge-performed-by-Client4Xi: " + str(deliver_challenge4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
            except:
                message2print = "{hit" + "; deliver-challenge4xi-hit-by-Client4Xi: " + " *** " + str(deliver_challenge4xi)  + " *** " + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                             
        else:
            # -------------------------------------------------------------------------------------    
            #
            # -------------------------------------------------------------------------------------
            message2print = "{(Step 5/6b1) warning" + "; answer-challenge4xi-skipped-warning-by-Client4Xi: " + " ** " + str(answer_challenge4xi)  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                     
                               
            message2print = "{(Step 5/6b2) warning" + "; deliver-challenge4xi-skipped-warning-by-Client4Xi: " + " ** " + str(deliver_challenge4xi)  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                     
        
        # -----------------------------------------------------------------------------------------
        # (Step 6/6)           
        # -----------------------------------------------------------------------------------------    
        message2print = "{(Step 5/6) returning" + "; connection2xi-returning-by-Client4Xi: " + str(connection2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
                
                
        
        return connection2xi
    # -----------------------------------------------------------------------------------------
    #           
    # -----------------------------------------------------------------------------------------
#</function4xi> 
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#
#<record4xi record = "
#   test_proxy_mp_xi4.py.txt
#   sense-proxy-mp-test4xi.xml
#   reason-proxy-mp-test4xi.xml
#   ace-proxy-mp-test4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

    
    

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of client4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

